package de.juplo.autoconfigure;


import com.fasterxml.jackson.core.JsonFactory;
import de.juplo.jackson.SimpleMapperService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;



/**
 *
 * @author Kai Moritz
 */
@ConditionalOnMissingBean(SimpleMapperService.class)
public class SimpleMapperServiceAutoConfiguration
{
  private final Logger LOG =
      LoggerFactory.getLogger(SimpleMapperServiceAutoConfiguration.class);


  @Bean
  public SimpleMapperService simpleMapperService(JsonFactory factory)
  {
    LOG.info("No SimpleMapperService configured: creating instance.");
    return new SimpleMapperService(factory);
  }

  @Bean
  @ConditionalOnMissingBean(JsonFactory.class)
  public JsonFactory jsonFactory()
  {
    LOG.info("No JsonFactory configured: configuring default factory.");
    return new JsonFactory();
  }
}
